{% extends "application.html" %}
{% block style %}

    <meta name="csrf-token" content="{{ csrf_token() }}">
    <link href='{{ url_for("static", filename="js/plugin/fullcalendar/packages/core/main.css") }}' rel='stylesheet'/>
    <link href='{{ url_for("static", filename="js/plugin/fullcalendar/packages/bootstrap/main.css") }}'
          rel='stylesheet'/>
    <link href='{{ url_for("static", filename="js/plugin/fullcalendar/packages/daygrid/main.css") }}' rel='stylesheet'/>
    <link href='{{ url_for("static", filename="js/plugin/fullcalendar/packages/timegrid/main.css") }}'
          rel='stylesheet'/>
    <link href='{{ url_for("static", filename="js/plugin/fullcalendar/packages/list/main.css") }}' rel='stylesheet'/>

    <link href='{{ url_for("static", filename="css/sweetalert2.min.css") }}' rel='stylesheet'/>
    <style>
        .fc-content {
            color: #ffffff;
        }

        #external-events {
            width: 150px;
            padding: 0 10px;
            border: none;
            background: #eee;
            padding-bottom: 10px;
        }

        #external-events h4 {
            font-size: 16px;
            margin-top: 0;
            padding-top: 1em;
        }

        #external-events .fc-event {
            margin: 10px 0;
            cursor: pointer;
        }

        #external-events p {
            margin: 1.5em 0;
            font-size: 11px;
            color: #666;
        }

        #external-events p input {
            margin: 0;
            vertical-align: middle;
        }
    </style>

{% endblock %}
{% block content %}
    <div class="container-fluid">

        <div class="row d-flex justify-content-between">
            <h1 class="h3 mb-2 text-gray-800">Lịch hẹn khám chữa bệnh</h1>
        </div>


        <div class="card shadow mb-4">
            <div class="card-body">
                <div class="row mb-3">
                    <div class="col-md-12">
                        <span><i class="fa fa-square bg-active"></i> Lịch còn hiệu lực</span>
                        <span><i class="fa fa-square bg-deactive"></i> Lịch bị hoãn</span>
                        <span>
                            <div id='external-events'>
{#                            <h4>Thẻ</h4>#}
                            <div id='external-events-list'>
{#                                <div class='fc-event'>Nghỉ</div>#}
{#                                <div class='fc-event'>Lịch khám</div>#}
                            </div>

                        </div>
                        <p>
                            <input type='checkbox' id='drop-remove' hidden/>
                            <label for='drop-remove' hidden>remove after drop</label>
                        </p>
                        </span>
                    </div>
                </div>
                <input type="text" value="{{ doctor.id }}" id="doctor_id" hidden>

                <div id='calendar'></div>
                <div style='clear:both'></div>
            </div>
        </div>
    </div>
{% endblock %}
{% block script %}

    <script src='{{ url_for("static", filename="js/plugin/fullcalendar/packages/core/main.js") }}'></script>
    <script src='{{ url_for("static", filename="js/plugin/fullcalendar/packages/daygrid/main.js") }}'></script>
    <script src='{{ url_for("static", filename="js/plugin/fullcalendar/packages/interaction/main.js") }}'></script>
    <script src='{{ url_for("static", filename="js/plugin/fullcalendar/packages/timegrid/main.js") }}'></script>
    <script src='{{ url_for("static", filename="js/plugin/fullcalendar/packages/list/main.js") }}'></script>
    <script src='{{ url_for("static", filename="js/plugin/fullcalendar/packages/core/locales-all.js") }}'></script>

    <script src='{{ url_for("static", filename="js/sweetalert2.all.min.js") }}'></script>

    <script>
        var csrftoken = $('meta[name=csrf-token]').attr('content');

        $.ajaxSetup({
            beforeSend: function (xhr, settings) {
                if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                    xhr.setRequestHeader("X-CSRFToken", csrftoken)
                }
            }
        });


        document.addEventListener('DOMContentLoaded', function () {

            var Calendar = FullCalendar.Calendar;
            var Draggable = FullCalendarInteraction.Draggable;

            /* initialize the external events
            -----------------------------------------------------------------*/

            var containerEl = document.getElementById('external-events-list');
            new Draggable(containerEl, {
                itemSelector: '.fc-event',
                eventData: function (eventEl) {
                    return {
                        title: eventEl.innerText.trim()
                    }
                }
            });


            var calendarEl = document.getElementById('calendar');

            var calendar = new FullCalendar.Calendar(calendarEl, {
                plugins: ['interaction', 'dayGrid', 'timeGrid', 'list'],

                header: {
                    left: 'prev,next today',
                    center: 'title',
                    right: 'dayGridMonth,timeGridWeek,timeGridDay,listMonth'
                },
                locale: 'vi',

                // customize the button names,
                // otherwise they'd all just say "list"
                // views: {
                //     listDay: {buttonText: 'Theo Ngày'},
                //     listWeek: {buttonText: 'Theo Tuần'}
                // },

                defaultView: 'dayGridMonth',
                // defaultDate: '2019-08-12',
                navLinks: true,
                editable: true,
                eventLimit: true,
                droppable: true, // this allows things to be dropped onto the calendar
                drop: function (arg) {
                    Swal.fire({
                        title: 'Bạn có muốn thêm lịch nghỉ?',
                        type: 'info',
                        showCancelButton: true,
                        confirmButtonColor: '#3085d6',
                        cancelButtonColor: '#d33',
                        confirmButtonText: 'Thêm lịch nghỉ',
                        cancelButtonText: 'Hủy'
                    }).then((result) => {
                        if (result.value) {
                            openReasonPopup(arg, 3);
                        }
                    });
                    // is the "remove after drop" checkbox checked?
                    if (document.getElementById('drop-remove').checked) {
                        // if so, remove the element from the "Draggable Events" list
                        arg.draggedEl.parentNode.removeChild(arg.draggedEl);
                    }
                },
                events: '/admin/ajax/appointment/list/' + $('#doctor_id').val(),
                eventClick: function (arg) {
                    Swal.fire({
                        title: 'Chọn hành động?',
                        type: 'info',
                        showCancelButton: true,
                        confirmButtonColor: '#3085d6',
                        cancelButtonColor: '#d33',
                        confirmButtonText: 'Hủy lịch hẹn',
                        cancelButtonText: 'Hủy'
                    }).then((result) => {
                        if (result.value) {
                            openReasonPopup(arg, 1);
                        }
                    });


                    // arg.event.remove();
                    // console.log(arg.event.id);
                    // if (confirm('Hủy cuộc hẹn?')) {
                    //     $.ajax({
                    //         url: '/admin/ajax/appointment/delete/' + arg.event.id,
                    //         type: 'GET'
                    //     }).done(function (result) {
                    //
                    //         console.log(result);
                    //         toastr.success(result.message, result.code);
                    //         arg.event.remove();
                    //     });
                    //
                    // }
                },
                eventDrop: function (event, delta, revertFunc) {
                    // console.log(event.event.start);
                    // console.log(event.event.end);
                    //
                    // console.log(event.oldEvent.start);
                    // console.log(event.oldEvent.end);
                    openReasonPopup(event, 2);

                    // $.ajax({
                    //   url: "/admin/ajax/appointment/change",
                    // type: "POST",
                    //credentials: 'include',
                    //                   contentType: "application/json",
                    //                 data: JSON.stringify({
                    //                   id: event.event.id,
                    //                 time_start: event.event.start,
                    //               time_finish: event.event.end
                    //         }),
                    //       dataType: "json",
                    // }).done(function (request) {
                    //   toastr.success(request.message, request.code);
                    //}).fail(function (request) {
                    //  toastr.error("Có lối xảy ra");
                    //});
                }
            });

            calendar.render();


            function openReasonPopup(event, type) {
                if (type == 3) {
                    $.ajax({
                        url: "/admin/ajax/appointment/offset",
                        type: "POST",
                        credentials: 'include',
                        contentType: "application/json",
                        data: JSON.stringify({
                            allday: event.allDay,
                            doctor_id: $('#doctor_id').val(),
                            time: event.date,
                            title: "Nghỉ"
                        }),
                        dataType: "json",
                    }).done(function (request) {
                        toastr.success(request.message, request.status);
                    }).fail(function (request) {
                        toastr.error("Có lối xảy ra");
                    });
                } else {
                    Swal.fire({
                        title: 'Thông điệp',
                        input: 'text',
                        inputAttributes: {
                            autocapitalize: 'off'
                        },
                        showCancelButton: true,
                        confirmButtonText: 'Gửi',
                        cancelButtonText: 'Hủy',
                        showLoaderOnConfirm: true,
                        preConfirm: (data) => {
                            if (type == 1) {
                                $.ajax({
                                    url: "/admin/ajax/appointment/delete",
                                    type: "POST",
                                    credentials: 'include',
                                    contentType: "application/json",
                                    data: JSON.stringify({
                                        id: event.event.id,
                                        content: data,
                                    }),
                                    dataType: "json",
                                }).done(function (request) {

                                    calendar.refetchEvents();
                                    toastr.success(request.message, request.status);
                                }).fail(function (request) {
                                    toastr.error("Có lối xảy ra");
                                });
                            } else if (type == 2) {
                                $.ajax({
                                    url: "/admin/ajax/appointment/change",
                                    type: "POST",
                                    credentials: 'include',
                                    contentType: "application/json",
                                    data: JSON.stringify({
                                        id: event.event.id,
                                        time_start: event.event.start,
                                        time_finish: event.event.end,
                                        content: data,
                                    }),
                                    dataType: "json",
                                }).done(function (request) {
                                    toastr.success(request.message, request.status);
                                }).fail(function (request) {
                                    toastr.error("Có lối xảy ra");
                                });
                            }

                        },
                        allowOutsideClick: () => !Swal.isLoading()
                    }).then(result => {
                        calendar.refetchEvents();

                    })
                }
                calendar.refetchEvents();
            }
        });

    </script>
{% endblock %}